
var array = require('../src/array-includes-polyfill-es6');
var chai = require('chai');
var expect = chai.expect;


describe('Trash Features', function () {
  it('Trashes a simple object', function(){
    var arr = new array();
    arr.push({test:'test'});
    arr.trash({test:'test'});
    expect(arr.length).equals(0);
  });

  it('Trashes a complex object', function(){

    var arr = new array();
    arr.push({test:{id:1234, delete:true}});
    arr.push({tset:{id:4321, delete:true}});
    arr.push({id:4312, sett:{delete:true}});

    arr.trash({test:{id:1234, delete:true}});
    console.log(arr);
    arr.trash({tset:{id:4321}});
    console.log(arr);
    arr.trash({id:4312});
    console.log(arr);

    console.log(arr.length);


    expect(arr.length).equals(0);

  });

  it("Doesn't trash if nothing is provided", function(){
      var arr = new array();
      arr.push({test:"test"});
      arr.push({tset: "tset"});
      arr.trash();
      arr.trash({})
      console.log(arr);

      expect(arr.length).equals(2);

  });

  it("Doesn't break if a bad object is given", function(){
    var arr = new array();
    arr.push({test:"test"});
    arr.push({tset: "tset"});

    console.log(arr.trash({bad:'input'}));
    console.log(arr);

    expect(arr.length).equals(2);
  });


});
